accounts/urls.py
from django.urls import path
from django.contrib.auth import views as auth_views
from accounts.views import signup

urlpatterns = [
    path("login/", auth_views.LoginView.as_view(), name="login"),
    path("signup/", signup, name="signup"),
    path("logout/", auth_views.LogoutView.as_view(), name="logout"),
]

expenses/urls.py
from django.contrib import admin
from django.urls import path, include
from django.views.generic.base import RedirectView
from django.urls import reverse_lazy

urlpatterns = [
    path("admin/", admin.site.urls),
    path("accounts/", include("accounts.urls")),
    path("receipts/", include("receipts.urls")),
    path("", RedirectView.as_view(url=reverse_lazy("home"))),
]

receipts/urls.py
from django.urls import path
from receipts.views import (
    ReceiptListView,
    AccountListView,
    ExpenseCategoryListView,
    ReceiptCreateView,
    AccountCreateView,
    ExpenseCategoryCreateView,
)

urlpatterns = [
    path("", ReceiptListView.as_view(), name="home"),
    path("accounts/", AccountListView.as_view(), name="account_list"),
    path("category/", ExpenseCategoryListView.as_view(), name="category_list"),
    path(
        "category/create",
        ExpenseCategoryCreateView.as_view(),
        name="category_create",
    ),
    path("account/create", AccountCreateView.as_view(), name="account_create"),
    path("create/", ReceiptCreateView.as_view(), name="receipt_create"),
]

accounts/models.py
from django.db import models

# Create your models here.

receipts/models.py
from tkinter import CASCADE
from django.db import models
from django.conf import settings


USER_MODEL = settings.AUTH_USER_MODEL

# Create your models here.
class ExpenseCategory(models.Model):
    name = models.CharField(max_length=50)
    owner = models.ForeignKey(
        USER_MODEL, related_name="categories", on_delete=models.CASCADE
    )

    def __str__(self):
        return self.name


class Account(models.Model):
    name = models.CharField(max_length=100)
    number = models.CharField(max_length=20)
    owner = models.ForeignKey(
        USER_MODEL, related_name="accounts", on_delete=models.CASCADE
    )

    def __str__(self):
        return self.name


class Receipt(models.Model):
    vendor = models.CharField(max_length=200)
    total = models.DecimalField(max_digits=10, decimal_places=3)
    tax = models.DecimalField(max_digits=10, decimal_places=3)
    date = models.DateField()
    purchaser = models.ForeignKey(
        USER_MODEL, related_name="receipts", on_delete=models.CASCADE
    )
    category = models.ForeignKey(
        "ExpenseCategory", related_name="receipts", on_delete=models.CASCADE
    )
    account = models.ForeignKey(
        "Account", related_name="receipts", on_delete=models.CASCADE, null=True
    )

accounts/views.py
from pdb import post_mortem
from django.shortcuts import render, redirect
from django.views.generic.list import ListView
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth import login, authenticate, logout
from django.contrib.auth.models import User

# Create your views here.
def signup(request):
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid:
            username = request.POST["username"]
            password = request.POST["password1"]
            user = User.objects.create_user(username, password)
            user.save()
            login(request, user)
            return redirect("home")
    else:
        form = UserCreationForm(request.POST)
    context = {"form": form}
    return render(request, "registration/signup.html", context)

receipts/views.py
from django.shortcuts import render
from django.views.generic.base import TemplateView
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic.edit import CreateView
from django.views.generic.list import ListView
from django.shortcuts import redirect

from receipts.models import Account, ExpenseCategory, Receipt


class ReceiptListView(LoginRequiredMixin, ListView):
    model: Receipt
    template_name = "receipts/list.html"

    def get_queryset(self):
        return Receipt.objects.filter(purchaser=self.request.user)


class ExpenseCategoryListView(LoginRequiredMixin, ListView):
    model: ExpenseCategory
    template_name = "category/list.html"

    def get_queryset(self):
        return ExpenseCategory.objects.filter(owner=self.request.user)


class AccountListView(LoginRequiredMixin, ListView):
    model: Account
    template_name = "account/list.html"

    def get_queryset(self):
        return Account.objects.filter(owner=self.request.user)


class ExpenseCategoryCreateView(LoginRequiredMixin, CreateView):
    model = ExpenseCategory
    template_name = "category/create.html"
    fields = [
        "name",
    ]

    def form_valid(self, form):
        item = form.save(commit=False)
        item.owner = self.request.user
        item.save()
        return redirect("category_list")


class AccountCreateView(LoginRequiredMixin, CreateView):
    model = Account
    template_name = "account/create.html"
    fields = [
        "name",
        "number",
    ]

    def form_valid(self, form):
        item = form.save(commit=False)
        item.owner = self.request.user
        item.save()
        return redirect("account_list")


class ReceiptCreateView(LoginRequiredMixin, CreateView):
    model = Receipt
    template_name = "receipts/create.html"
    fields = [
        "vendor",
        "tax",
        "total",
        "date",
        "category",
        "account",
    ]

    def form_valid(self, form):
        item = form.save(commit=False)
        item.purchaser = self.request.user
        item.save()
        return redirect("home")

accounts/templates/base.html
<!DOCTYPE html>
<html lang="en">


<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=\, initial-scale=1.0">
    <title>Document</title>
</head>

<body>
    <main>
        <ul>
            {% if request.user.is_authenticated %}
            <li>
                <a href=" {%url 'logout' %}">Log Out</a>
            </li>
            {% else %}
            <li>
                <a href=" {%url 'signup' %}">Sign Up</a>
            </li>
            <li>
                <a href=" {%url 'login' %}">Log In</a>
            </li>
            {% endif %}
        </ul>
        <ul>
            {% if request.user.is_authenticated %}
            <li>
                <a href=" {%url 'home' %}">Home</a>
            </li>
            <li>
                <a href=" {%url 'receipt_create' %}">Create a Receipt</a>
            </li>
            <li>
                <a href=" {%url 'account_list' %}">Account</a>
            </li>
            <li>
                <a href=" {%url 'account_create' %}">Create an Account</a>
            </li>
            <li>
                <a href=" {%url 'category_list' %}">Expense Category</a>
            </li>
            <li>
                <a href=" {%url 'category_create' %}">Create an Expense Category</a>
            </li>
            {% endif %}
        </ul>
        {% block content %}
        {% endblock content %}
    </main>
</body>

</html>

receipts/templates/category/create.html
{% extends 'base.html' %}


{% block content %}
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button>Category</button>
</form>
{% endblock content %}

receipts/templates/category/list.html
{% extends 'base.html' %}


{% block content %}
<table>
    <thead>
        <tr>
            <th>Name</th>
            <th>Number of Receipts</th>
        </tr>
    </thead>
    <tbody>
        {% for category in expensecategory_list %}
        <tr>
            <td>{{category.name}}</td>
            <td>{{category.receipts.all|length}}</td>
        </tr>
        {% endfor %}
    </tbody>
</table>>
{% endblock content %}

receipts/templates/receipts/create.html
{% extends 'base.html' %}

{% block content %}
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button>Receipts</button>
</form>
{% endblock content %}

receipts/templates/receipts/list.html
{% extends 'base.html' %}
{% block content %}
<h1>Home</h1>

<table>
    <thead>
        <tr>
            <th>Vendor</th>
            <th>Total</th>
            <th>Tax</th>
            <th>Date</th>
            <th>Category</th>
            <th>Account</th>
        </tr>
    </thead>
    <tbody>
        {% for receipt in receipt_list %}
        <tr>
            <td>{{receipt.vendor}}</td>
            <td>{{receipt.total}}</td>
            <td>{{receipt.tax}}</td>
            <td>{{receipt.date}}</td>
            <td>{{receipt.category}}</td>
            <td>{{receipt.account}}</td>
        </tr>
        {% endfor %}
    </tbody>
</table>>
{% endblock content %}